var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "like-ar"], factory);
    }
})(function (require, exports) {
    //import { TableDefinition } from "backend-plus";
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.LocalDbTransaction = exports.LocalDb = exports.detectedFeatures = void 0;
    //x// <amd-dependency path="../../../node_modules/like-ar/like-ar.d.ts" name="likeAr"/>
    //x// <reference path="../../node_modules/like-ar/like-ar.d.ts" />
    /// <reference path="../node_modules/types.d.ts/modules/myOwn/in-myOwn.d.ts" />
    /// <reference path="../../../lib/in-backend-plus.d.ts" />
    /// <reference path="../../../lib/backend-plus.d.ts" />
    /// <reference path="../../lib/in-backend-plus.d.ts" />
    /// <reference path="../../lib/backend-plus.d.ts" />
    /// <reference path="../lib/in-backend-plus.d.ts" />
    /// <reference path="../lib/backend-plus.d.ts" />
    /// <reference path="lib/in-backend-plus.d.ts" />
    /// <reference path="lib/backend-plus.d.ts" />
    /****
     * Atención en la implementación de este módulo se tiene en cuenta que según
     * https://caniuse.com/#feat=indexeddb ocurren dos cosas trágicas:
     *   1) en IE y EDGE no hay claves de tipo array
     *   2) en iOS de 8 a 9.3 hay un error que no permite que en dos objetos distintos haya una misma Pk
     *
     * más explicaciones en:
     *   1) https://stackoverflow.com/questions/14283257/dataerror-when-creating-an-index-with-a-compound-key-in-ie-10
     *   2) https://www.raymondcamden.com/2014/09/25/IndexedDB-on-iOS-8-Broken-Bad/
     *
     * hay un test en:
     *   a) https://codepen.io/cemerick/pen/Itymi
     *
     * workarround para contemplar IE, y iOS viejos:
     *   1) se transforman las claves antes de usarlas en un string (JSON.stringify del array para el problema del IE)
     *   2) se prefija el string con el nombre del objectStore (para que todas las claves sean distintas y no haya problemas con el iOS viejo)
     *
     * detección
     *   1) por ahora solo probamos la detección del problema del array de claves
     *   2) TODO: Falta programar la detección del problema de iOS viejo, quizás haya que ser explícito, hay que probarlo con varios iPad
     */
    var likeAr = require("like-ar");
    exports.detectedFeatures = {
        needToUnwrapArrayKeys: null
    };
    var LocalDb = /** @class */ (function () {
        function LocalDb(name) {
            this.name = name;
            var ldb = this;
            var initialStores = {
                $structures: 'name',
                $internals: 'var',
                $detect: ['detectKey'],
            };
            var initialVersionInfo = {
                var: 'version',
                num: 1,
                timestamp: new Date().toJSON(),
                stores: initialStores
            };
            var requestDB = indexedDB.open(this.name);
            requestDB.onupgradeneeded = function () {
                var db = requestDB.result;
                if (!db.objectStoreNames.contains("$internals")) {
                    likeAr(initialStores).forEach(function (keyPath, tableName) {
                        var store = db.createObjectStore(tableName, { keyPath: keyPath });
                        if (tableName == '$internals') {
                            store.put(initialVersionInfo);
                        }
                        if (tableName == '$detect') {
                            ldb.wait4detectedFeatures = ldb.detectFeatures(store);
                        }
                    });
                }
            };
            ldb.wait4db = ldb.IDBX(requestDB);
        }
        LocalDb.deleteDatabase = function (name) {
            var request = indexedDB.deleteDatabase(name);
            return new Promise(function (resolve, reject) {
                request.onsuccess = function () {
                    resolve();
                };
                request.onerror = function (event) {
                    reject();
                };
            });
        };
        LocalDb.prototype.IDBX = function (request) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, new Promise(function (resolve, reject) {
                            if ('onsuccess' in request) {
                                request.onsuccess = function () {
                                    resolve(request.result);
                                };
                            }
                            else {
                                request.oncomplete = function () {
                                    resolve();
                                };
                            }
                            request.onerror = function () {
                                alertPromise(request.error.message || request.error.name);
                                reject(request.error);
                            };
                        })];
                });
            });
        };
        LocalDb.prototype.registerStructure = function (tableDef) {
            return __awaiter(this, void 0, void 0, function () {
                var ldb, wait4dbCurrent, registerTask, result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            ldb = this;
                            wait4dbCurrent = this.wait4db;
                            registerTask = this.registerStructureInside(tableDef, wait4dbCurrent);
                            this.wait4db = registerTask.then(function (result) { return result.wait4db; });
                            return [4 /*yield*/, registerTask];
                        case 1:
                            result = _a.sent();
                            return [2 /*return*/, result.result];
                    }
                });
            });
        };
        LocalDb.prototype.detectFeatures = function (store) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, new Promise(function (resolve) {
                            try {
                                // @ts-ignore
                                var os = window.myOwn.config.useragent.os;
                                // @ts-ignore
                                var version = parseInt(window.myOwn.config.useragent.version.split('.')[0]);
                            }
                            catch (err) {
                                throw Error("unknowed OS or version");
                            }
                            if (os === 'OS X' && version < 11) {
                                exports.detectedFeatures.needToUnwrapArrayKeys = true;
                                resolve(exports.detectedFeatures);
                            }
                            else {
                                var request = store.put({ detectKey: 'one' });
                                request.onsuccess = function () {
                                    var key = request.result;
                                    if (typeof key === "string") {
                                        exports.detectedFeatures.needToUnwrapArrayKeys = true;
                                    }
                                    else {
                                        exports.detectedFeatures.needToUnwrapArrayKeys = false;
                                    }
                                    resolve(exports.detectedFeatures);
                                };
                                request.onerror = function () {
                                    exports.detectedFeatures.needToUnwrapArrayKeys = true;
                                    resolve(exports.detectedFeatures);
                                };
                            }
                        })];
                });
            });
        };
        LocalDb.prototype.registerStructureInside = function (tableDef, wait4db) {
            return __awaiter(this, void 0, void 0, function () {
                var ldb, db, result, oldValue, infoStore, versionInfo, requestDB;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            ldb = this;
                            return [4 /*yield*/, wait4db];
                        case 1:
                            db = _a.sent();
                            result = { wait4db: wait4db, result: { changed: null } };
                            return [4 /*yield*/, this.IDBX(db.transaction('$structures', "readonly").objectStore('$structures').get(tableDef.name))];
                        case 2:
                            oldValue = _a.sent();
                            if (!oldValue) {
                                result.result.new = true;
                            }
                            return [4 /*yield*/, ldb.IDBX(db.transaction('$structures', "readwrite").objectStore('$structures').put(tableDef))];
                        case 3:
                            _a.sent();
                            result.result.changed = JSON.stringify(tableDef) != JSON.stringify(oldValue);
                            if (!ldb.wait4detectedFeatures) {
                                ldb.wait4detectedFeatures = ldb.detectFeatures(db.transaction('$detect', "readwrite").objectStore('$detect'));
                            }
                            return [4 /*yield*/, ldb.wait4detectedFeatures];
                        case 4:
                            _a.sent();
                            infoStore = exports.detectedFeatures.needToUnwrapArrayKeys ? null : tableDef.primaryKey;
                            return [4 /*yield*/, this.IDBX(db.transaction('$internals', "readonly").objectStore('$internals').get('version'))];
                        case 5:
                            versionInfo = _a.sent();
                            if (!(JSON.stringify(versionInfo.stores[tableDef.name]) != JSON.stringify(infoStore))) return [3 /*break*/, 8];
                            db.close();
                            versionInfo.num++;
                            requestDB = indexedDB.open(this.name, versionInfo.num);
                            requestDB.onupgradeneeded = function () {
                                var db = requestDB.result;
                                if (versionInfo.stores[tableDef.name]) {
                                    db.deleteObjectStore(tableDef.name);
                                }
                                if (infoStore != null) {
                                    db.createObjectStore(tableDef.name, { keyPath: infoStore });
                                }
                                else {
                                    db.createObjectStore(tableDef.name);
                                }
                            };
                            result.wait4db = ldb.IDBX(requestDB);
                            return [4 /*yield*/, result.wait4db];
                        case 6:
                            db = _a.sent();
                            versionInfo.stores[tableDef.name] = infoStore;
                            return [4 /*yield*/, ldb.IDBX(db.transaction('$internals', "readwrite").objectStore('$internals').put(versionInfo))];
                        case 7:
                            _a.sent();
                            _a.label = 8;
                        case 8: return [2 /*return*/, result];
                    }
                });
            });
        };
        LocalDb.prototype.getStructure = function (tableName) {
            return __awaiter(this, void 0, void 0, function () {
                var ldb, db, tableDef;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            ldb = this;
                            return [4 /*yield*/, ldb.wait4db];
                        case 1:
                            db = _a.sent();
                            if (!ldb.wait4detectedFeatures) {
                                ldb.wait4detectedFeatures = ldb.detectFeatures(db.transaction('$detect', "readwrite").objectStore('$detect'));
                            }
                            return [4 /*yield*/, ldb.wait4detectedFeatures];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, ldb.IDBX(db.transaction('$structures', "readonly").objectStore('$structures').get(tableName))];
                        case 3:
                            tableDef = _a.sent();
                            return [2 /*return*/, tableDef];
                    }
                });
            });
        };
        LocalDb.prototype.existsStructure = function (tableName) {
            return __awaiter(this, void 0, void 0, function () {
                var tableDef;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getStructure(tableName)];
                        case 1:
                            tableDef = _a.sent();
                            return [2 /*return*/, tableDef ? true : false];
                    }
                });
            });
        };
        LocalDb.prototype.getOneIfExists = function (tableName, key) {
            return __awaiter(this, void 0, void 0, function () {
                var ldb, db, internalKey, result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            ldb = this;
                            return [4 /*yield*/, ldb.wait4db];
                        case 1:
                            db = _a.sent();
                            if (exports.detectedFeatures.needToUnwrapArrayKeys) {
                                internalKey = tableName + JSON.stringify(key);
                            }
                            else {
                                internalKey = key;
                            }
                            return [4 /*yield*/, ldb.IDBX(db.transaction(tableName, "readonly").objectStore(tableName).get(internalKey))];
                        case 2:
                            result = _a.sent();
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        LocalDb.prototype.getOne = function (tableName, key) {
            return __awaiter(this, void 0, void 0, function () {
                var result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getOneIfExists(tableName, key)];
                        case 1:
                            result = _a.sent();
                            if (!result) {
                                throw new Error("no result");
                            }
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        LocalDb.prototype.getChild = function (tableName, parentKey) {
            return __awaiter(this, void 0, void 0, function () {
                var ldb, db, rows, internalKey, cursor;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            ldb = this;
                            return [4 /*yield*/, ldb.wait4db];
                        case 1:
                            db = _a.sent();
                            rows = [];
                            if (exports.detectedFeatures.needToUnwrapArrayKeys) {
                                internalKey = tableName + JSON.stringify(parentKey);
                                internalKey = internalKey.substr(0, internalKey.length - 1);
                            }
                            else {
                                internalKey = parentKey ? parentKey : '';
                            }
                            cursor = db.transaction([tableName], 'readonly').objectStore(tableName).openCursor(parentKey == null ? null : IDBKeyRange.lowerBound(internalKey));
                            return [2 /*return*/, new Promise(function (resolve, reject) {
                                    cursor.onsuccess = function (event) {
                                        // @ts-ignore target no conoce result en la definición de TS. Verificar dentro de un tiempo si TS mejoró
                                        var cursor = event.target.result;
                                        if (cursor && ((parentKey == null) || (exports.detectedFeatures.needToUnwrapArrayKeys ?
                                            internalKey == cursor.key.slice(0, internalKey.length) :
                                            !parentKey.find(function (expectedValue, i) {
                                                var storedValue = cursor.key[i];
                                                return expectedValue != storedValue;
                                            })))) {
                                            rows.push(cursor.value);
                                            cursor.continue();
                                        }
                                        else {
                                            resolve(rows);
                                        }
                                    };
                                    cursor.onerror = function () {
                                        reject(cursor.error);
                                    };
                                })];
                    }
                });
            });
        };
        LocalDb.prototype.getAll = function (tableName) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.getChild(tableName, tableName[0] == '$' ? null : [])];
                });
            });
        };
        LocalDb.prototype.getAllStructures = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.getAll('$structures')];
                });
            });
        };
        LocalDb.prototype.isEmpty = function (tableName) {
            return __awaiter(this, void 0, void 0, function () {
                var ldb, db, count;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            ldb = this;
                            return [4 /*yield*/, ldb.wait4db];
                        case 1:
                            db = _a.sent();
                            return [4 /*yield*/, ldb.IDBX(db.transaction(tableName, "readonly").objectStore(tableName).count())];
                        case 2:
                            count = _a.sent();
                            return [2 /*return*/, count == 0];
                    }
                });
            });
        };
        LocalDb.prototype.putOneAndGetIfNeeded = function (tableName, element, needed) {
            return __awaiter(this, void 0, void 0, function () {
                var ldb, db, tableDef, createPromiseForFK, promisesArray;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            ldb = this;
                            return [4 /*yield*/, ldb.wait4db];
                        case 1:
                            db = _a.sent();
                            return [4 /*yield*/, ldb.getStructure(tableName)];
                        case 2:
                            tableDef = _a.sent();
                            createPromiseForFK = function createPromiseForFK(fk) {
                                return Promise.resolve().then(function () {
                                    return __awaiter(this, void 0, void 0, function () {
                                        var fkTableDef, pk, isFKCompleteInSource, fkRecord;
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0: return [4 /*yield*/, ldb.getStructure(fk.references)];
                                                case 1:
                                                    fkTableDef = _a.sent();
                                                    if (!fkTableDef) return [3 /*break*/, 3];
                                                    pk = [];
                                                    fk.fields.forEach(function (field) {
                                                        pk.push(element[field.source]);
                                                    });
                                                    isFKCompleteInSource = fk.fields.filter(function (field) {
                                                        return element[field.source] == null;
                                                    }).length == 0;
                                                    if (!isFKCompleteInSource) return [3 /*break*/, 3];
                                                    return [4 /*yield*/, ldb.getOneIfExists(fk.references, pk)];
                                                case 2:
                                                    fkRecord = _a.sent();
                                                    if (fkRecord) {
                                                        fk.displayFields.forEach(function (field) {
                                                            element[fk.alias + '__' + field] = fkRecord[field];
                                                        });
                                                    }
                                                    _a.label = 3;
                                                case 3: return [2 /*return*/];
                                            }
                                        });
                                    });
                                });
                            };
                            promisesArray = [];
                            if (tableDef.foreignKeys) {
                                tableDef.foreignKeys.forEach(function (fk) {
                                    return __awaiter(this, void 0, void 0, function () {
                                        return __generator(this, function (_a) {
                                            promisesArray.push(createPromiseForFK(fk));
                                            return [2 /*return*/];
                                        });
                                    });
                                });
                            }
                            if (tableDef.softForeignKeys) {
                                tableDef.softForeignKeys.forEach(function (fk) {
                                    return __awaiter(this, void 0, void 0, function () {
                                        return __generator(this, function (_a) {
                                            promisesArray.push(createPromiseForFK(fk));
                                            return [2 /*return*/];
                                        });
                                    });
                                });
                            }
                            return [2 /*return*/, Promise.all(promisesArray).then(function () {
                                    return __awaiter(this, void 0, void 0, function () {
                                        var newKey, storeTask, storeTask, key;
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0:
                                                    if (exports.detectedFeatures.needToUnwrapArrayKeys) {
                                                        newKey = tableName + JSON.stringify(tableDef.primaryKey.map(function (name) {
                                                            return element[name];
                                                        }));
                                                        storeTask = db.transaction(tableName, "readwrite").objectStore(tableName).put(element, newKey);
                                                    }
                                                    else {
                                                        storeTask = db.transaction(tableName, "readwrite").objectStore(tableName).put(element);
                                                    }
                                                    if (!needed) return [3 /*break*/, 3];
                                                    return [4 /*yield*/, ldb.IDBX(storeTask)];
                                                case 1:
                                                    key = _a.sent();
                                                    return [4 /*yield*/, ldb.IDBX(db.transaction(tableName, "readonly").objectStore(tableName).get(key))];
                                                case 2: return [2 /*return*/, _a.sent()];
                                                case 3: return [2 /*return*/, null];
                                            }
                                        });
                                    });
                                })];
                    }
                });
            });
        };
        LocalDb.prototype.putOne = function (tableName, element) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.putOneAndGetIfNeeded(tableName, element, true)];
                });
            });
        };
        LocalDb.prototype.putMany = function (tableName, elements) {
            return __awaiter(this, void 0, void 0, function () {
                function putNext() {
                    if (i < elements.length) {
                        if (exports.detectedFeatures.needToUnwrapArrayKeys) {
                            var newKey = tableName + JSON.stringify(tableDef.primaryKey.map(function (name) {
                                return elements[i][name];
                            }));
                            objectStore.put(elements[i], newKey).onsuccess = putNext;
                        }
                        else {
                            objectStore.put(elements[i]).onsuccess = putNext;
                        }
                        ++i;
                    }
                    else {
                        return Promise.resolve();
                    }
                }
                var ldb, db, tableDef, transaction, objectStore, i;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            ldb = this;
                            return [4 /*yield*/, ldb.wait4db];
                        case 1:
                            db = _a.sent();
                            return [4 /*yield*/, ldb.getStructure(tableName)];
                        case 2:
                            tableDef = _a.sent();
                            transaction = db.transaction(tableName, "readwrite");
                            objectStore = transaction.objectStore(tableName);
                            i = 0;
                            putNext();
                            return [2 /*return*/];
                    }
                });
            });
        };
        LocalDb.prototype.close = function () {
            return __awaiter(this, void 0, void 0, function () {
                var db;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.wait4db];
                        case 1:
                            db = _a.sent();
                            db.close();
                            this.wait4db = {
                                then: function () {
                                    throw new Error("the database is closed");
                                },
                                catch: function () {
                                    throw new Error("the database is closed");
                                }
                            };
                            return [2 /*return*/];
                    }
                });
            });
        };
        LocalDb.prototype.clear = function (tableName) {
            return __awaiter(this, void 0, void 0, function () {
                var ldb, db;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            ldb = this;
                            return [4 /*yield*/, ldb.wait4db];
                        case 1:
                            db = _a.sent();
                            return [4 /*yield*/, ldb.IDBX(db.transaction(tableName, "readwrite").objectStore(tableName).clear())];
                        case 2:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        return LocalDb;
    }());
    exports.LocalDb = LocalDb;
    var LocalDbTransaction = /** @class */ (function () {
        function LocalDbTransaction(localDbName) {
            this.localDbName = localDbName;
            this.oneByOneChain = Promise.resolve();
            this.oneByOneChain = Promise.resolve();
        }
        LocalDbTransaction.prototype.inTransaction = function (callback) {
            return __awaiter(this, void 0, void 0, function () {
                var name;
                return __generator(this, function (_a) {
                    name = this.localDbName;
                    this.oneByOneChain = this.oneByOneChain.then(function () {
                        return __awaiter(this, void 0, void 0, function () {
                            function closeLdb(previousError) {
                                return __awaiter(this, void 0, void 0, function () {
                                    var errClose_1;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                _a.trys.push([0, 2, , 3]);
                                                return [4 /*yield*/, ldb.close()];
                                            case 1:
                                                _a.sent();
                                                if (previousError) {
                                                    // @ts-ignore 
                                                    previousError.ldbWasClosed = true;
                                                }
                                                return [3 /*break*/, 3];
                                            case 2:
                                                errClose_1 = _a.sent();
                                                if (previousError) {
                                                    // @ts-ignore 
                                                    previousError.ldbWasNotClosedBecause = errClose_1;
                                                }
                                                else {
                                                    throw errClose_1;
                                                }
                                                return [3 /*break*/, 3];
                                            case 3: return [2 /*return*/];
                                        }
                                    });
                                });
                            }
                            var ldb, result, err_1;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        ldb = new LocalDb(name);
                                        _a.label = 1;
                                    case 1:
                                        _a.trys.push([1, 3, , 5]);
                                        return [4 /*yield*/, callback(ldb)];
                                    case 2:
                                        result = _a.sent();
                                        return [3 /*break*/, 5];
                                    case 3:
                                        err_1 = _a.sent();
                                        return [4 /*yield*/, closeLdb(err_1)];
                                    case 4:
                                        _a.sent();
                                        throw err_1;
                                    case 5: 
                                    //await closeLdb();
                                    return [2 /*return*/, result];
                                }
                            });
                        });
                    });
                    return [2 /*return*/, this.oneByOneChain];
                });
            });
        };
        LocalDbTransaction.prototype.getBindedInTransaction = function () {
            var this4bind = this;
            return function (ldb) {
                return this4bind.inTransaction(ldb);
            };
        };
        return LocalDbTransaction;
    }());
    exports.LocalDbTransaction = LocalDbTransaction;
});
//# sourceMappingURL=my-localdb.js.map